/******************************************************************************
 * Copyright (c) 1998 by Mindbright Technology AB, Stockholm, Sweden.
 *
 *                        All Rights Reserved
 *
 *               www.mindbright.se, info@mindbright.se
 *
 * This program and its source-code may be used FREE of charge for strictly
 * NON-COMMERCIAL purposes. Companies or persons wishing to make non-commercial
 * software that in whole or in part contains or is derived from this program
 * or any part thereof must inform the original author of such work. The
 * original author must also be given attribution as the author of used parts.
 * For COMMERCIAL use all parts of this program originally developed by
 * Mindbright Technology must be LICENSED under Mindbright Technology's
 * SHAREWARE license, please contact Mindbright Technology for information on
 * this. This copyright notice must allways be included and unchanged.
 *
 * IF LICENSED FREE OF CHARGE AND/OR IF NOT STATED OTHERWISE THIS PROGRAM COMES
 * WITH NO WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, IN NO EVENT SHALL
 * MINDBRIGHT BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
 * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER
 * IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT
 * OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 *****************************************************************************/
/*
 * !!! Author's comment: The contents of this file is heavily based upon
 * xterm from the X Consortium, original copyright notices included
 * below.
 */
/*
Copyright (c) 1988  X Consortium

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
X CONSORTIUM BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN
AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

Except as contained in this notice, the name of the X Consortium shall not be
used in advertising or otherwise to promote the sale, use or other dealings
in this Software without prior written authorization from the X Consortium.

*/
/*
 * Copyright 1987 by Digital Equipment Corporation, Maynard, Massachusetts.
 *
 *                         All Rights Reserved
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation, and that the name of Digital Equipment
 * Corporation not be used in advertising or publicity pertaining to
 * distribution of the software without specific, written prior permission.
 *
 *
 * DIGITAL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING
 * ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL
 * DIGITAL BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR
 * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS,
 * WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS
 * SOFTWARE.
 */
package mindbright.terminal;

public class TerminalVT100 extends TerminalInterpreter {

  public final static boolean DEBUG = false;

  public final static int CASE_GROUND_STATE  = 0;
  public final static int CASE_IGNORE_STATE  = 1;
  public final static int CASE_IGNORE_ESC    = 2;
  public final static int CASE_IGNORE        = 3;
  public final static int CASE_BELL          = 4;
  public final static int CASE_BS            = 5;
  public final static int CASE_CR            = 6;
  public final static int CASE_ESC           = 7;
  public final static int CASE_VMOT          = 8;
  public final static int CASE_TAB           = 9;
  public final static int CASE_SI            = 10;
  public final static int CASE_SO            = 11;
  public final static int CASE_SCR_STATE     = 12;
  public final static int CASE_SCS0_STATE    = 13;
  public final static int CASE_SCS1_STATE    = 14;
  public final static int CASE_SCS2_STATE    = 15;
  public final static int CASE_SCS3_STATE    = 16;
  public final static int CASE_ESC_IGNORE    = 17;
  public final static int CASE_ESC_DIGIT     = 18;
  public final static int CASE_ESC_SEMI      = 19;
  public final static int CASE_DEC_STATE     = 20;
  public final static int CASE_ICH           = 21;
  public final static int CASE_CUU           = 22;
  public final static int CASE_CUD           = 23;
  public final static int CASE_CUF           = 24;
  public final static int CASE_CUB           = 25;
  public final static int CASE_CUP           = 26;
  public final static int CASE_ED            = 27;
  public final static int CASE_EL            = 28;
  public final static int CASE_IL            = 29;
  public final static int CASE_DL            = 30;
  public final static int CASE_DCH           = 31;
  public final static int CASE_DA1           = 32;
  public final static int CASE_TRACK_MOUSE   = 33;
  public final static int CASE_TBC           = 34;
  public final static int CASE_SET           = 35;
  public final static int CASE_RST           = 36;
  public final static int CASE_SGR           = 37;
  public final static int CASE_CPR           = 38;
  public final static int CASE_DECSTBM       = 39;
  public final static int CASE_DECREQTPARM   = 40;
  public final static int CASE_DECSET        = 41;
  public final static int CASE_DECRST        = 42;
  public final static int CASE_DECALN        = 43;
  public final static int CASE_GSETS         = 44;
  public final static int CASE_DECSC         = 45;
  public final static int CASE_DECRC         = 46;
  public final static int CASE_DECKPAM       = 47;
  public final static int CASE_DECKPNM       = 48;
  public final static int CASE_IND           = 49;
  public final static int CASE_NEL           = 50;
  public final static int CASE_HTS           = 51;
  public final static int CASE_RI            = 52;
  public final static int CASE_SS2           = 53;
  public final static int CASE_SS3           = 54;
  public final static int CASE_CSI_STATE     = 55;
  public final static int CASE_OSC           = 56;
  public final static int CASE_RIS           = 57;
  public final static int CASE_LS2           = 58;
  public final static int CASE_LS3           = 59;
  public final static int CASE_LS3R          = 60;
  public final static int CASE_LS2R          = 61;
  public final static int CASE_LS1R          = 62;
  public final static int CASE_PRINT         = 63;
  public final static int CASE_XTERM_SAVE    = 64;
  public final static int CASE_XTERM_RESTORE = 65;
  public final static int CASE_XTERM_TITLE   = 66;
  public final static int CASE_DECID         = 67;
  public final static int CASE_HP_MEM_LOCK   = 68;
  public final static int CASE_HP_MEM_UNLOCK = 69;
  public final static int CASE_HP_BUGGY_LL   = 70;

  public final static int PARAMNOTUSED = -1;

  int[] parseState;
  int   scsType;

  boolean windowRelative;
  boolean keypadAppl;

  int[] param  = new int[10];
  int   nparam ;

  public TerminalVT100() {
    parseState     = groundTable;
    windowRelative = false;
  }

  public String terminalType() {
    return "vt100";
  }

  public int interpretChar(char c) {
    int val;
    switch(parseState[c]) {
    case CASE_PRINT:
      if(DEBUG) System.out.println("PRINT: " + c);
      return (int) c;
    case CASE_GROUND_STATE:
      if(DEBUG) System.out.println("GND_STATE");
      parseState = groundTable;
      break;
    case CASE_IGNORE_STATE:
      if(DEBUG) System.out.println("IGN_STATE");
      parseState = ignTable;
      break;
    case CASE_IGNORE_ESC:
      if(DEBUG) System.out.println("IGN_ESC");
      parseState = iesTable;
      break;
    case CASE_IGNORE:
      if(DEBUG) System.out.println("IGNORE");
      break;
    case CASE_BELL:
      if(DEBUG) System.out.println("BELL");
      term.doBell();
      break;
    case CASE_BS:
      if(DEBUG) System.out.println("BS");
      term.doBS();
      break;
    case CASE_CR:
      if(DEBUG) System.out.println("CR");
      term.doCR();
      parseState = groundTable;
      break;
    case CASE_ESC:
      if(DEBUG) System.out.println("ESC");
      parseState = escTable;
      break;
    case CASE_VMOT:
      if(DEBUG) System.out.println("VMOT");
      term.doLF();
      parseState = groundTable;
      break;
    case CASE_TAB:
      if(DEBUG) System.out.println("TAB");
      term.doTab();
      break;
    case CASE_SI:
      if(DEBUG) notImplemented("SI");
      break;
    case CASE_SO:
      if(DEBUG) notImplemented("SO");
      break;
    case CASE_SCR_STATE:
      if(DEBUG) System.out.println("SCR_STATE");
      parseState = scrTable;
      break;
    case CASE_SCS0_STATE:
      if(DEBUG) System.out.println("SCS0");
      scsType    = 0;
      parseState = scsTable;
      break;
    case CASE_SCS1_STATE:
      if(DEBUG) System.out.println("SCS1");
      scsType    = 1;
      parseState = scsTable;
      break;
    case CASE_SCS2_STATE:
      if(DEBUG) System.out.println("SCS2");
      scsType    = 2;
      parseState = scsTable;
      break;
    case CASE_SCS3_STATE:
      if(DEBUG) System.out.println("SCS3");
      scsType    = 3;
      parseState = scsTable;
      break;
    case CASE_ESC_IGNORE:
      if(DEBUG) System.out.println("ESC_IGN");
      parseState = eigTable;
      break;
    case CASE_ESC_DIGIT:
      if(DEBUG) System.out.println("ESC_DIGIT");
      val = param[nparam - 1];
      if(val == PARAMNOTUSED)
	val = 0;
      param[nparam - 1] = 10 * val + (c - '0');
      break;
    case CASE_ESC_SEMI:
      if(DEBUG) System.out.println("ESC_SEMI");
      param[nparam++] = PARAMNOTUSED;
      break;
    case CASE_DEC_STATE:
      if(DEBUG) System.out.println("DEC_STATE");
      parseState = decTable;
      break;
    case CASE_ICH:
      if(DEBUG) System.out.println("ICH");
      val = param[0];
      if(val < 1)
	val = 1;
      term.insertChars(val);
      parseState = groundTable;
      break;
    case CASE_CUU:
      if(DEBUG) System.out.println("CUU");
      val = param[0];
      if(val < 1)
	val = 1;
      term.cursorUp(val);
      parseState = groundTable;
      break;
    case CASE_CUD:
      if(DEBUG) System.out.println("CUD");
      val = param[0];
      if(val < 1)
	val = 1;
      term.cursorDown(val);
      parseState = groundTable;
      break;
    case CASE_CUF:
      if(DEBUG) System.out.println("CUF");
      val = param[0];
      if(val < 1)
	val = 1;
      term.cursorForward(val);
      parseState = groundTable;
      break;
    case CASE_CUB:
      if(DEBUG) System.out.println("CUB");
      val = param[0];
      if(val < 1)
	val = 1;
      term.cursorBackward(val);
      parseState = groundTable;
      break;
    case CASE_CUP:
      if(DEBUG) System.out.println("CUP");
      int v = param[0];
      int h = param[1];
      if(v < 1)
	v = 1;
      if(nparam < 2 || h < 1)
	h = 1;
      term.cursorSetPos(v - 1, h - 1, windowRelative);
      parseState = groundTable;
      break;
    case CASE_ED:
      if(DEBUG) System.out.println("ED");
      switch(param[0]) {
      case PARAMNOTUSED:
      case 0:
	term.clearBelow();
	break;
      case 1:
	term.clearAbove();
	break;
      case 2:
	term.clearScreen();
	term.cursorSetPos(0, 0, windowRelative);
	break;
      }
      parseState = groundTable;
      break;
    case CASE_EL:
      if(DEBUG) System.out.println("EL");
      switch(param[0]) {
      case PARAMNOTUSED:
      case 0:
	term.clearRight();
	break;
      case 1:
	term.clearLeft();
	break;
      case 2:
	term.clearLine();
	break;
      }
      parseState = groundTable;
      break;
    case CASE_IL:
      if(DEBUG) System.out.println("IL");
      val = param[0];
      if(val < 1)
	val = 1;
      term.insertLines(val);
      parseState = groundTable;
      break;
    case CASE_DL:
      if(DEBUG) System.out.println("DL");
      val = param[0];
      if(val < 1)
	val = 1;
      term.deleteLines(val);
      parseState = groundTable;
      break;
    case CASE_DCH:
      if(DEBUG) System.out.println("DCH");
      val = param[0];
      if(val < PARAMNOTUSED)
	val = 1;
      term.deleteChars(val);
      parseState = groundTable;
      break;
    case CASE_DECID:
      if(DEBUG) notImplemented("DECID");
      param[0] = PARAMNOTUSED;
      break;
    case CASE_DA1:
      if(DEBUG) notImplemented("DA1");
      parseState = groundTable;
      break;
    case CASE_TRACK_MOUSE:
      if(DEBUG) notImplemented("TRACK_MOUSE");
      break;
    case CASE_TBC:
      if(DEBUG) notImplemented("TBC");
      parseState = groundTable;
      break;
    case CASE_SET:
      if(DEBUG) System.out.println("SET");
      ansiModes(true);
      parseState = groundTable;
      break;
    case CASE_RST:
      if(DEBUG) System.out.println("RST");
      ansiModes(false);
      parseState = groundTable;
      break;
    case CASE_SGR:
      if(DEBUG) System.out.println("SGR");
      for(int i = 0; i < nparam; i++) {
	switch(param[i]) {
	case PARAMNOTUSED:
	case 0:
	  term.clearAllAttributes();
	  break;
	case 1:
	case 5:
	  // !!! Should be Hilite/blinking...
	  term.setBold(true);
	  break;
	case 4:
	  term.setUnderline(true);
	  break;
	case 7:
	  term.setInverseVideo(true);
	  break;
	case 30:
	case 31:
	case 32:
	case 33:
	case 34:
	case 35:
	case 36:
	case 37:
	  term.setForegroundColor(param[i] - 30);
	  break;
	case 40:
	case 41:
	case 42:
	case 43:
	case 44:
	case 45:
	case 46:
	case 47:
	  term.setBackgroundColor(param[i] - 40);
	  break;
	}
      }
      parseState = groundTable;
      break;
    case CASE_CPR:
      if(DEBUG) notImplemented("CPR");
      parseState = groundTable;
      break;
    case CASE_DECSTBM:
      if(DEBUG) System.out.println("DECSTBM");
      int top = param[0];
      int bot = param[1];
      if(top < 1)
	top = 1;
      if(nparam < 2 || bot == PARAMNOTUSED || bot == 0 || bot > term.rows())
	bot = term.rows();
      if(bot > top) {
	term.setWindow(top - 1, bot);
	term.cursorSetPos(0, 0, windowRelative);
      }
      parseState = groundTable;
      break;
    case CASE_DECREQTPARM:
      if(DEBUG) notImplemented("DECREQTPARM");
      parseState = groundTable;
      break;
    case CASE_DECSET:
      if(DEBUG) System.out.println("DECSET");
      dpModes(true);
      parseState = groundTable;
      break;
    case CASE_DECRST:
      if(DEBUG) System.out.println("DECRST");
      dpModes(false);
      parseState = groundTable;
      break;
    case CASE_DECALN:
      if(DEBUG) notImplemented("DECALN");
      parseState = groundTable;
      break;
    case CASE_GSETS:
      if(DEBUG) notImplemented("GSETS");
      parseState = groundTable;
      break;
    case CASE_DECSC:
      if(DEBUG) System.out.println("DECSC");
      term.cursorSave();
      parseState = groundTable;
      break;
    case CASE_DECRC:
      if(DEBUG) System.out.println("DECRC");
      term.cursorRestore();
      parseState = groundTable;
      break;
    case CASE_DECKPAM:
      if(DEBUG) System.out.println("DECKPAM");
      keypadAppl = true;
      parseState = groundTable;
      break;
    case CASE_DECKPNM:
      if(DEBUG) System.out.println("DECKPNM");
      keypadAppl = false;
      parseState = groundTable;
      break;
    case CASE_IND:
      term.cursorIndex(1);
      parseState = groundTable;
      break;
    case CASE_NEL:
      if(DEBUG) System.out.println("NEL");
      term.cursorIndex(1);
      term.doCR();
      parseState = groundTable;
      break;
    case CASE_HTS:
      if(DEBUG) notImplemented("HTS");
      parseState = groundTable;
      break;
    case CASE_RI:
      if(DEBUG) System.out.println("RI");
      term.cursorIndexRev(1);
      parseState = groundTable;
      break;
    case CASE_SS2:
      if(DEBUG) notImplemented("SS2");
      parseState = groundTable;
      break;
    case CASE_SS3:
      if(DEBUG) notImplemented("SS3");
      parseState = groundTable;
      break;
    case CASE_CSI_STATE:
      if(DEBUG) System.out.println("CSI_STATE");
      param[0]   = PARAMNOTUSED;
      nparam     = 1;
      parseState = csiTable;
      break;
    case CASE_OSC:
      if(DEBUG) notImplemented("OSC");
      parseState = groundTable;
      break;
    case CASE_RIS:
      if(DEBUG) System.out.println("RIS");
      vtReset();
      parseState = groundTable;
      break;
    case CASE_LS2:
      if(DEBUG) notImplemented("LS2");
      parseState = groundTable;
      break;
    case CASE_LS3:
      if(DEBUG) notImplemented("LS3");
      parseState = groundTable;
      break;
    case CASE_LS3R:
      if(DEBUG) notImplemented("LS3R");
      parseState = groundTable;
      break;
    case CASE_LS2R:
      if(DEBUG) notImplemented("LS2R");
      parseState = groundTable;
      break;
    case CASE_LS1R:
      if(DEBUG) notImplemented("LS1R");
      parseState = groundTable;
      break;
    case CASE_XTERM_SAVE:
      if(DEBUG) notImplemented("XTERM_SAVE");
      parseState = groundTable;
      break;
    case CASE_XTERM_RESTORE:
      if(DEBUG) notImplemented("XTERM_RESTORE");
      parseState = groundTable;
      break;
    case CASE_XTERM_TITLE:
      if(DEBUG) notImplemented("XTERM_TITLE");
      break;
    case CASE_HP_MEM_LOCK:
      if(DEBUG) notImplemented("HP_MEM_LOCK");
      parseState = groundTable;
      break;
    case CASE_HP_MEM_UNLOCK:
      if(DEBUG) notImplemented("HP_MEM_UNLOCK");
      parseState = groundTable;
      break;
    case CASE_HP_BUGGY_LL:
      if(DEBUG) notImplemented("HP_BUGGY_LL");
      parseState = groundTable;
      break;
    default:
      if(DEBUG) System.out.println("** Unknown state !!!");
      break;
    }
    return IGNORE;
  }

  protected void ansiModes(boolean set) {
    for(int i = 0; i < nparam; i++) {
      switch(param[i]) {
      case 4:
	if(DEBUG) notImplemented("IRM");
	break;
      case 20:
	if(DEBUG) notImplemented("LNM");
	break;
      }
    }
  }

  protected void dpModes(boolean set) {
    for(int i = 0; i < nparam; i++) {
      switch(param[i]) {
      case 1:
	if(DEBUG) System.out.println("DECCKM");
	term.setCursorKeysMode(set);
	break;
      case 2:
	if(DEBUG) notImplemented("ANSI/VT52");
	break;
      case 3:
	if(DEBUG) notImplemented("DECCOLM");
	break;
      case 4:
	if(DEBUG) notImplemented("DECSCLM");
	break;
      case 5:
	if(DEBUG) System.out.println("DECSCNM");
	term.setReverseVideo(!set);
	break;
      case 6:
	if(DEBUG) System.out.println("DECOM");
	windowRelative = set;
	break;
      case 7:
	if(DEBUG) System.out.println("DECAWM");
	term.setAutoWrap(set);
	break;
      case 8:
	if(DEBUG) notImplemented("DECARM");
	break;
      case 9:
	if(DEBUG) notImplemented("MIT-BOGUS");
	break;
      case 38:
	if(DEBUG) notImplemented("DECTEK");
	break;
      case 40:
	if(DEBUG) notImplemented("DEC132COLS");
	break;
      case 41:
	if(DEBUG) notImplemented("DECCUR-HACK");
	break;
      case 44:
	if(DEBUG) notImplemented("DECMRGBEL");
	break;
      case 45:
	if(DEBUG) notImplemented("DECREVWA");
	break;
      case 46:
	if(DEBUG) notImplemented("DECLOG");
	break;
      case 47:
	if(DEBUG) notImplemented("DECALTBUF");
	break;
      case 1000:
	if(DEBUG) notImplemented("XTERM-BOGUS");
	break;
      case 1001:
	if(DEBUG) notImplemented("XTERM-HILITETRAK");
	break;
      }
    }
  }

  protected void vtReset() {
    term.resetWindow();
    windowRelative = false;
    term.setCursorKeysMode(false);
    keypadAppl     = false;
    term.clearScreen();
    term.cursorSetPos(0, 0, false);
  }

  protected void notImplemented(String cmd) {
    System.out.println("not implemented: " + cmd);
  }


  public final static int[] groundTable =
  {
    /*	NUL		SOH		STX		ETX	*/
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*	EOT		ENQ		ACK		BEL	*/
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_BELL,
    /*	BS		HT		NL		VT	*/
    CASE_BS,
    CASE_TAB,
    CASE_VMOT,
    CASE_VMOT,
    /*	NP		CR		SO		SI	*/
    CASE_VMOT,
    CASE_CR,
    CASE_SO,
    CASE_SI,
    /*	DLE		DC1		DC2		DC3	*/
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*	DC4		NAK		SYN		ETB	*/
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*	CAN		EM		SUB		ESC	*/
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_ESC,
    /*	FS		GS		RS		US	*/
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*	SP		!		"		#	*/
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*	$		%		&		'	*/
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*	(		)		*		+	*/
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*	,		-		.		/	*/
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*	0		1		2		3	*/
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*	4		5		6		7	*/
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*	8		9		:		;	*/
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*	<		=		>		?	*/
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT, 
    /*	@		A		B		C	*/
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*	D		E		F		G	*/
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*	H		I		J		K	*/
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*	L		M		N		O	*/
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*	P		Q		R		S	*/
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*	T		U		V		W	*/
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*	X		Y		Z		[	*/
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*	\		]		^		_	*/
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*	`		a		b		c	*/
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*	d		e		f		g	*/
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*	h		i		j		k	*/
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*	l		m		n		o	*/
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*	p		q		r		s	*/
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*	t		u		v		w	*/
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*	x		y		z		{	*/
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*	|		}		~		DEL	*/
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_GROUND_STATE,
    /*      0x80            0x81            0x82            0x83    */
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*      0x84            0x85            0x86            0x87    */
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*      0x88            0x89            0x8a            0x8b    */
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*      0x8c            0x8d            0x8e            0x8f    */
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*      0x90            0x91            0x92            0x93    */
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*      0x94            0x95            0x96            0x97    */
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*      0x99            0x99            0x9a            0x9b    */
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*      0x9c            0x9d            0x9e            0x9f    */
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*      nobreakspace    exclamdown      cent            sterling        */
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*      currency        yen             brokenbar       section         */
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*      diaeresis       copyright       ordfeminine     guillemotleft   */
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*      notsign         hyphen          registered      macron          */
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*      degree          plusminus       twosuperior     threesuperior   */
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*      acute           mu              paragraph       periodcentered  */
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*      cedilla         onesuperior     masculine       guillemotright  */
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*      onequarter      onehalf         threequarters   questiondown    */
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*      Agrave          Aacute          Acircumflex     Atilde          */
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*      Adiaeresis      Aring           AE              Ccedilla        */
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*      Egrave          Eacute          Ecircumflex     Ediaeresis      */
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*      Igrave          Iacute          Icircumflex     Idiaeresis      */
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*      Eth             Ntilde          Ograve          Oacute          */
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*      Ocircumflex     Otilde          Odiaeresis      multiply        */
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*      Ooblique        Ugrave          Uacute          Ucircumflex     */
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*      Udiaeresis      Yacute          Thorn           ssharp          */
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*      agrave          aacute          acircumflex     atilde          */
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*      adiaeresis      aring           ae              ccedilla        */
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*      egrave          eacute          ecircumflex     ediaeresis      */
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*      igrave          iacute          icircumflex     idiaeresis      */
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*      eth             ntilde          ograve          oacute          */
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*      ocircumflex     otilde          odiaeresis      division        */
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*      oslash          ugrave          uacute          ucircumflex     */
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    /*      udiaeresis      yacute          thorn           ydiaeresis      */
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
    CASE_PRINT,
  };

  // ESC [
  public final static int[] csiTable=
  {
    /*	NUL		SOH		STX		ETX	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	EOT		ENQ		ACK		BEL	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_BELL,
    /*	BS		HT		NL		VT	*/
    CASE_BS,
    CASE_TAB,
    CASE_VMOT,
    CASE_VMOT,
    /*	NP		CR		SO		SI	*/
    CASE_VMOT,
    CASE_CR,
    CASE_SO,
    CASE_SI,
    /*	DLE		DC1		DC2		DC3	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	DC4		NAK		SYN		ETB	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	CAN		EM		SUB		ESC	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_ESC,
    /*	FS		GS		RS		US	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	SP		!		"		#	*/
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    /*	$		%		&		'	*/
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    /*	(		)		*		+	*/
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    /*	,		-		.		/	*/
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    /*	0		1		2		3	*/
    CASE_ESC_DIGIT,
    CASE_ESC_DIGIT,
    CASE_ESC_DIGIT,
    CASE_ESC_DIGIT,
    /*	4		5		6		7	*/
    CASE_ESC_DIGIT,
    CASE_ESC_DIGIT,
    CASE_ESC_DIGIT,
    CASE_ESC_DIGIT,
    /*	8		9		:		;	*/
    CASE_ESC_DIGIT,
    CASE_ESC_DIGIT,
    CASE_IGNORE,
    CASE_ESC_SEMI,
    /*	<		=		>		?	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_DEC_STATE,
    /*	@		A		B		C	*/
    CASE_ICH,
    CASE_CUU,
    CASE_CUD,
    CASE_CUF,
    /*	D		E		F		G	*/
    CASE_CUB,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	H		I		J		K	*/
    CASE_CUP,
    CASE_GROUND_STATE,
    CASE_ED,
    CASE_EL,
    /*	L		M		N		O	*/
    CASE_IL,
    CASE_DL,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	P		Q		R		S	*/
    CASE_DCH,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	T		U		V		W	*/
    CASE_TRACK_MOUSE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	X		Y		Z		[	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	\		]		^		_	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	`		a		b		c	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_DA1,
    /*	d		e		f		g	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_CUP,
    CASE_TBC,
    /*	h		i		j		k	*/
    CASE_SET,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	l		m		n		o	*/
    CASE_RST,
    CASE_SGR,
    CASE_CPR,
    CASE_GROUND_STATE,
    /*	p		q		r		s	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_DECSTBM,
    CASE_DECSC,
    /*	t		u		v		w	*/
    CASE_GROUND_STATE,
    CASE_DECRC,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	x		y		z		{	*/
    CASE_DECREQTPARM,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	|		}		~		DEL	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      0x80            0x81            0x82            0x83    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x84            0x85            0x86            0x87    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x88            0x89            0x8a            0x8b    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x8c            0x8d            0x8e            0x8f    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x90            0x91            0x92            0x93    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x94            0x95            0x96            0x97    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x99            0x99            0x9a            0x9b    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x9c            0x9d            0x9e            0x9f    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      nobreakspace    exclamdown      cent            sterling        */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      currency        yen             brokenbar       section         */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      diaeresis       copyright       ordfeminine     guillemotleft   */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      notsign         hyphen          registered      macron          */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      degree          plusminus       twosuperior     threesuperior   */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      acute           mu              paragraph       periodcentered  */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      cedilla         onesuperior     masculine       guillemotright  */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      onequarter      onehalf         threequarters   questiondown    */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Agrave          Aacute          Acircumflex     Atilde          */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Adiaeresis      Aring           AE              Ccedilla        */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Egrave          Eacute          Ecircumflex     Ediaeresis      */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Igrave          Iacute          Icircumflex     Idiaeresis      */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Eth             Ntilde          Ograve          Oacute          */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Ocircumflex     Otilde          Odiaeresis      multiply        */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Ooblique        Ugrave          Uacute          Ucircumflex     */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Udiaeresis      Yacute          Thorn           ssharp          */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      agrave          aacute          acircumflex     atilde          */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      adiaeresis      aring           ae              ccedilla        */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      egrave          eacute          ecircumflex     ediaeresis      */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      igrave          iacute          icircumflex     idiaeresis      */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      eth             ntilde          ograve          oacute          */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      ocircumflex     otilde          odiaeresis      division        */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      oslash          ugrave          uacute          ucircumflex     */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      udiaeresis      yacute          thorn           ydiaeresis      */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
  };

  // ESC [ ? 
  public final static int[] decTable =
  {
    /*	NUL		SOH		STX		ETX	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	EOT		ENQ		ACK		BEL	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_BELL,
    /*	BS		HT		NL		VT	*/
    CASE_BS,
    CASE_TAB,
    CASE_VMOT,
    CASE_VMOT,
    /*	NP		CR		SO		SI	*/
    CASE_VMOT,
    CASE_CR,
    CASE_SO,
    CASE_SI,
    /*	DLE		DC1		DC2		DC3	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	DC4		NAK		SYN		ETB	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	CAN		EM		SUB		ESC	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_ESC,
    /*	FS		GS		RS		US	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	SP		!		"		#	*/
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    /*	$		%		&		'	*/
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    /*	(		)		*		+	*/
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    /*	,		-		.		/	*/
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    /*	0		1		2		3	*/
    CASE_ESC_DIGIT,
    CASE_ESC_DIGIT,
    CASE_ESC_DIGIT,
    CASE_ESC_DIGIT,
    /*	4		5		6		7	*/
    CASE_ESC_DIGIT,
    CASE_ESC_DIGIT,
    CASE_ESC_DIGIT,
    CASE_ESC_DIGIT,
    /*	8		9		:		;	*/
    CASE_ESC_DIGIT,
    CASE_ESC_DIGIT,
    CASE_IGNORE,
    CASE_ESC_SEMI,
    /*	<		=		>		?	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	@		A		B		C	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	D		E		F		G	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	H		I		J		K	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	L		M		N		O	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	P		Q		R		S	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	T		U		V		W	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	X		Y		Z		[	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	\		]		^		_	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	`		a		b		c	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	d		e		f		g	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	h		i		j		k	*/
    CASE_DECSET,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	l		m		n		o	*/
    CASE_DECRST,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	p		q		r		s	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_XTERM_RESTORE,
    CASE_XTERM_SAVE,
    /*	t		u		v		w	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	x		y		z		{	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	|		}		~		DEL	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      0x80            0x81            0x82            0x83    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x84            0x85            0x86            0x87    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x88            0x89            0x8a            0x8b    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x8c            0x8d            0x8e            0x8f    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x90            0x91            0x92            0x93    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x94            0x95            0x96            0x97    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x99            0x99            0x9a            0x9b    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x9c            0x9d            0x9e            0x9f    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      nobreakspace    exclamdown      cent            sterling        */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      currency        yen             brokenbar       section         */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      diaeresis       copyright       ordfeminine     guillemotleft   */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      notsign         hyphen          registered      macron          */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      degree          plusminus       twosuperior     threesuperior   */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      acute           mu              paragraph       periodcentered  */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      cedilla         onesuperior     masculine       guillemotright  */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      onequarter      onehalf         threequarters   questiondown    */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Agrave          Aacute          Acircumflex     Atilde          */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Adiaeresis      Aring           AE              Ccedilla        */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Egrave          Eacute          Ecircumflex     Ediaeresis      */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Igrave          Iacute          Icircumflex     Idiaeresis      */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Eth             Ntilde          Ograve          Oacute          */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Ocircumflex     Otilde          Odiaeresis      multiply        */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Ooblique        Ugrave          Uacute          Ucircumflex     */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Udiaeresis      Yacute          Thorn           ssharp          */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      agrave          aacute          acircumflex     atilde          */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      adiaeresis      aring           ae              ccedilla        */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      egrave          eacute          ecircumflex     ediaeresis      */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      igrave          iacute          icircumflex     idiaeresis      */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      eth             ntilde          ograve          oacute          */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      ocircumflex     otilde          odiaeresis      division        */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      oslash          ugrave          uacute          ucircumflex     */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      udiaeresis      yacute          thorn           ydiaeresis      */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
  };

  // CASE_ESC_IGNORE
  public final static int[] eigTable =
  {
    /*	NUL		SOH		STX		ETX	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	EOT		ENQ		ACK		BEL	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_BELL,
    /*	BS		HT		NL		VT	*/
    CASE_BS,
    CASE_TAB,
    CASE_VMOT,
    CASE_VMOT,
    /*	NP		CR		SO		SI	*/
    CASE_VMOT,
    CASE_CR,
    CASE_SO,
    CASE_SI,
    /*	DLE		DC1		DC2		DC3	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	DC4		NAK		SYN		ETB	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	CAN		EM		SUB		ESC	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_ESC,
    /*	FS		GS		RS		US	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	SP		!		"		#	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	$		%		&		'	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	(		)		*		+	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	,
	-		.		/	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	0		1		2		3	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	4		5		6		7	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	8		9		:		;	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	<		=		>		?	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	@		A		B		C	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	D		E		F		G	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	H		I		J		K	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	L		M		N		O	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	P		Q		R		S	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	T		U		V		W	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	X		Y		Z		[	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	\		]		^		_	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	`		a		b		c	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	d		e		f		g	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	h		i		j		k	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	l		m		n		o	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	p		q		r		s	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	t		u		v		w	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	x		y		z		{	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	|		}		~		DEL	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      0x80            0x81            0x82            0x83    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x84            0x85            0x86            0x87    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x88            0x89            0x8a            0x8b    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x8c            0x8d            0x8e            0x8f    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x90            0x91            0x92            0x93    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x94            0x95            0x96            0x97    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x99            0x99            0x9a            0x9b    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x9c            0x9d            0x9e            0x9f    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      nobreakspace    exclamdown      cent            sterling        */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      currency        yen             brokenbar       section         */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      diaeresis       copyright       ordfeminine     guillemotleft   */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      notsign         hyphen          registered      macron          */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      degree          plusminus       twosuperior     threesuperior   */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      acute           mu              paragraph       periodcentered  */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      cedilla         onesuperior     masculine       guillemotright  */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      onequarter      onehalf         threequarters   questiondown    */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Agrave          Aacute          Acircumflex     Atilde          */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Adiaeresis      Aring           AE              Ccedilla        */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Egrave          Eacute          Ecircumflex     Ediaeresis      */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Igrave          Iacute          Icircumflex     Idiaeresis      */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Eth             Ntilde          Ograve          Oacute          */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Ocircumflex     Otilde          Odiaeresis      multiply        */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Ooblique        Ugrave          Uacute          Ucircumflex     */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Udiaeresis      Yacute          Thorn           ssharp          */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      agrave          aacute          acircumflex     atilde          */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      adiaeresis      aring           ae              ccedilla        */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      egrave          eacute          ecircumflex     ediaeresis      */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      igrave          iacute          icircumflex     idiaeresis      */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      eth             ntilde          ograve          oacute          */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      ocircumflex     otilde          odiaeresis      division        */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      oslash          ugrave          uacute          ucircumflex     */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      udiaeresis      yacute          thorn           ydiaeresis      */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
  };

  // ESC
  public final static int[] escTable =
  {
    /*	NUL		SOH		STX		ETX	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	EOT		ENQ		ACK		BEL	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_BELL,
    /*	BS		HT		NL		VT	*/
    CASE_BS,
    CASE_TAB,
    CASE_VMOT,
    CASE_VMOT,
    /*	NP		CR		SO		SI	*/
    CASE_VMOT,
    CASE_CR,
    CASE_SO,
    CASE_SI,
    /*	DLE		DC1		DC2		DC3	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	DC4		NAK		SYN		ETB	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	CAN		EM		SUB		ESC	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_ESC,
    /*	FS		GS		RS		US	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	SP		!		"		#	*/
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    CASE_SCR_STATE,
    /*	$		%		&		'	*/
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    /*	(		)		*		+	*/
    CASE_SCS0_STATE,
    CASE_SCS1_STATE,
    CASE_SCS2_STATE,
    CASE_SCS3_STATE,
    /*	,		-		.		/	*/
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    /*	0		1		2		3	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	4		5		6		7	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_DECSC,
    /*	8		9		:		;	*/
    CASE_DECRC,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	<		=		>		?	*/
    CASE_GROUND_STATE,
    CASE_DECKPAM,
    CASE_DECKPNM,
    CASE_GROUND_STATE,
    /*	@		A		B		C	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	D		E		F		G	*/
    CASE_IND,
    CASE_NEL,
    CASE_HP_BUGGY_LL,
    CASE_GROUND_STATE,
    /*	H		I		J		K	*/
    CASE_HTS,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	L		M		N		O	*/
    CASE_GROUND_STATE,
    CASE_RI,
    CASE_SS2,
    CASE_SS3,
    /*	P		Q		R		S	*/
    CASE_IGNORE_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	T		U		V		W	*/
    CASE_XTERM_TITLE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	X		Y		Z		[	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_DECID,
    CASE_CSI_STATE,
    /*	\		]		^		_	*/
    CASE_GROUND_STATE,
    CASE_OSC,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    /*	`		a		b		c	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_RIS,
    /*	d		e		f		g	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	h		i		j		k	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	l		m		n		o	*/
    CASE_HP_MEM_LOCK,
    CASE_HP_MEM_UNLOCK,
    CASE_LS2,
    CASE_LS3,
    /*	p		q		r		s	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	t		u		v		w	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	x		y		z		{	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	|		}		~		DEL	*/
    CASE_LS3R,
    CASE_LS2R,
    CASE_LS1R,
    CASE_GROUND_STATE,
    /*      0x80            0x81            0x82            0x83    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x84            0x85            0x86            0x87    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x88            0x89            0x8a            0x8b    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x8c            0x8d            0x8e            0x8f    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x90            0x91            0x92            0x93    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x94            0x95            0x96            0x97    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x99            0x99            0x9a            0x9b    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x9c            0x9d            0x9e            0x9f    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      nobreakspace    exclamdown      cent            sterling        */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      currency        yen             brokenbar       section         */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      diaeresis       copyright       ordfeminine     guillemotleft   */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      notsign         hyphen          registered      macron          */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      degree          plusminus       twosuperior     threesuperior   */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      acute           mu              paragraph       periodcentered  */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      cedilla         onesuperior     masculine       guillemotright  */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      onequarter      onehalf         threequarters   questiondown    */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Agrave          Aacute          Acircumflex     Atilde          */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Adiaeresis      Aring           AE              Ccedilla        */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Egrave          Eacute          Ecircumflex     Ediaeresis      */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Igrave          Iacute          Icircumflex     Idiaeresis      */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Eth             Ntilde          Ograve          Oacute          */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Ocircumflex     Otilde          Odiaeresis      multiply        */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Ooblique        Ugrave          Uacute          Ucircumflex     */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Udiaeresis      Yacute          Thorn           ssharp          */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      agrave          aacute          acircumflex     atilde          */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      adiaeresis      aring           ae              ccedilla        */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      egrave          eacute          ecircumflex     ediaeresis      */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      igrave          iacute          icircumflex     idiaeresis      */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      eth             ntilde          ograve          oacute          */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      ocircumflex     otilde          odiaeresis      division        */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      oslash          ugrave          uacute          ucircumflex     */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      udiaeresis      yacute          thorn           ydiaeresis      */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
  };

  // CASE_IGNORE_ESC
  public final static int[] iesTable =
  {
    /*	NUL		SOH		STX		ETX	*/
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    /*	EOT		ENQ		ACK		BEL	*/
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    /*	BS		HT		NL		VT	*/
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    /*	NP		CR		SO		SI	*/
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    /*	DLE		DC1		DC2		DC3	*/
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    /*	DC4		NAK		SYN		ETB	*/
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    /*	CAN		EM		SUB		ESC	*/
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    /*	FS		GS		RS		US	*/
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    /*	SP		!		"		#	*/
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    /*	$		%		&		'	*/
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    /*	(		)		*		+	*/
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    /*	,		-		.		/	*/
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    /*	0		1		2		3	*/
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    /*	4		5		6		7	*/
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    /*	8		9		:		;	*/
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    /*	<		=		>		?	*/
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    /*	@		A		B		C	*/
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    /*	D		E		F		G	*/
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    /*	H		I		J		K	*/
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    /*	L		M		N		O	*/
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    /*	P		Q		R		S	*/
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    /*	T		U		V		W	*/
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    /*	X		Y		Z		[	*/
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    /*	\		]		^		_	*/
    CASE_GROUND_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    /*	`		a		b		c	*/
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    /*	d		e		f		g	*/
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    /*	h		i		j		k	*/
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    /*	l		m		n		o	*/
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    /*	p		q		r		s	*/
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    /*	t		u		v		w	*/
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    /*	x		y		z		{	*/
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    /*	|		}		~		DEL	*/
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    CASE_IGNORE_STATE,
    /*      0x80            0x81            0x82            0x83    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x84            0x85            0x86            0x87    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x88            0x89            0x8a            0x8b    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x8c            0x8d            0x8e            0x8f    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x90            0x91            0x92            0x93    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x94            0x95            0x96            0x97    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x99            0x99            0x9a            0x9b    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x9c            0x9d            0x9e            0x9f    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      nobreakspace    exclamdown      cent            sterling        */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      currency        yen             brokenbar       section         */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      diaeresis       copyright       ordfeminine     guillemotleft   */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      notsign         hyphen          registered      macron          */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      degree          plusminus       twosuperior     threesuperior   */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      acute           mu              paragraph       periodcentered  */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      cedilla         onesuperior     masculine       guillemotright  */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      onequarter      onehalf         threequarters   questiondown    */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Agrave          Aacute          Acircumflex     Atilde          */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Adiaeresis      Aring           AE              Ccedilla        */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Egrave          Eacute          Ecircumflex     Ediaeresis      */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Igrave          Iacute          Icircumflex     Idiaeresis      */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Eth             Ntilde          Ograve          Oacute          */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Ocircumflex     Otilde          Odiaeresis      multiply        */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Ooblique        Ugrave          Uacute          Ucircumflex     */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Udiaeresis      Yacute          Thorn           ssharp          */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      agrave          aacute          acircumflex     atilde          */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      adiaeresis      aring           ae              ccedilla        */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      egrave          eacute          ecircumflex     ediaeresis      */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      igrave          iacute          icircumflex     idiaeresis      */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      eth             ntilde          ograve          oacute          */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      ocircumflex     otilde          odiaeresis      division        */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      oslash          ugrave          uacute          ucircumflex     */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      udiaeresis      yacute          thorn           ydiaeresis      */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
  };

  // CASE_IGNORE_STATE
  public final static int[] ignTable =
  {
    /*	NUL		SOH		STX		ETX	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	EOT		ENQ		ACK		BEL	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	BS		HT		NL		VT	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	NP		CR		SO		SI	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	DLE		DC1		DC2		DC3	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	DC4		NAK		SYN		ETB	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	CAN		EM		SUB		ESC	*/
    CASE_GROUND_STATE, 
    CASE_IGNORE,
    CASE_GROUND_STATE,
    CASE_IGNORE_ESC,
    /*	FS		GS		RS		US	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	SP		!		"		#	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	$		%		&		'	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	(		)		*		+	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	,		-		.		/	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	0		1		2		3	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	4		5		6		7	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	8		9		:		;	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	<		=		>		?	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	@		A		B		C	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	D		E		F		G	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	H		I		J		K	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	L		M		N		O	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	P		Q		R		S	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	T		U		V		W	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	X		Y		Z		[	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	\		]		^		_	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	`		a		b		c	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	d		e		f		g	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	h		i		j		k	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	l		m		n		o	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	p		q		r		s	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	t		u		v		w	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	x		y		z		{	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	|		}		~		DEL	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x80            0x81            0x82            0x83    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x84            0x85            0x86            0x87    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x88            0x89            0x8a            0x8b    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x8c            0x8d            0x8e            0x8f    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x90            0x91            0x92            0x93    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x94            0x95            0x96            0x97    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x99            0x99            0x9a            0x9b    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x9c            0x9d            0x9e            0x9f    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      nobreakspace    exclamdown      cent            sterling        */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      currency        yen             brokenbar       section         */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      diaeresis       copyright       ordfeminine     guillemotleft   */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      notsign         hyphen          registered      macron          */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      degree          plusminus       twosuperior     threesuperior   */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      acute           mu              paragraph       periodcentered  */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      cedilla         onesuperior     masculine       guillemotright  */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      onequarter      onehalf         threequarters   questiondown    */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Agrave          Aacute          Acircumflex     Atilde          */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Adiaeresis      Aring           AE              Ccedilla        */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Egrave          Eacute          Ecircumflex     Ediaeresis      */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Igrave          Iacute          Icircumflex     Idiaeresis      */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Eth             Ntilde          Ograve          Oacute          */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Ocircumflex     Otilde          Odiaeresis      multiply        */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Ooblique        Ugrave          Uacute          Ucircumflex     */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Udiaeresis      Yacute          Thorn           ssharp          */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      agrave          aacute          acircumflex     atilde          */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      adiaeresis      aring           ae              ccedilla        */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      egrave          eacute          ecircumflex     ediaeresis      */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      igrave          iacute          icircumflex     idiaeresis      */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      eth             ntilde          ograve          oacute          */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      ocircumflex     otilde          odiaeresis      division        */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      oslash          ugrave          uacute          ucircumflex     */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      udiaeresis      yacute          thorn           ydiaeresis      */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
  };

  // ESC # 
  public final static int[] scrTable =
  {
    /*	NUL		SOH		STX		ETX	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	EOT		ENQ		ACK		BEL	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_BELL,
    /*	BS		HT		NL		VT	*/
    CASE_BS,
    CASE_TAB,
    CASE_VMOT,
    CASE_VMOT,
    /*	NP		CR		SO		SI	*/
    CASE_VMOT,
    CASE_CR,
    CASE_SO,
    CASE_SI,
    /*	DLE		DC1		DC2		DC3	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	DC4		NAK		SYN		ETB	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	CAN		EM		SUB		ESC	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_ESC,
    /*	FS		GS		RS		US	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	SP		!		"		#	*/
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    /*	$		%		&		'	*/
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    /*	(		)		*		+	*/
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    /*	,		-		.		/	*/
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    /*	0		1		2		3	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	4		5		6		7	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	8		9		:		;	*/
    CASE_DECALN,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	<		=		>		?	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	@		A		B		C	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	D		E		F		G	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	H		I		J		K	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	L		M		N		O	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	P		Q		R		S	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	T		U		V		W	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	X		Y		Z		[	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	\		]		^		_	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	`		a		b		c	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	d		e		f		g	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	h		i		j		k	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	l		m		n		o	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	p		q		r		s	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	t		u		v		w	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	x		y		z		{	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	|		}		~		DEL	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      0x80            0x81            0x82            0x83    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x84            0x85            0x86            0x87    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x88            0x89            0x8a            0x8b    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x8c            0x8d            0x8e            0x8f    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x90            0x91            0x92            0x93    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x94            0x95            0x96            0x97    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x99            0x99            0x9a            0x9b    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x9c            0x9d            0x9e            0x9f    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      nobreakspace    exclamdown      cent            sterling        */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      currency        yen             brokenbar       section         */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      diaeresis       copyright       ordfeminine     guillemotleft   */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      notsign         hyphen          registered      macron          */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      degree          plusminus       twosuperior     threesuperior   */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      acute           mu              paragraph       periodcentered  */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      cedilla         onesuperior     masculine       guillemotright  */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      onequarter      onehalf         threequarters   questiondown    */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Agrave          Aacute          Acircumflex     Atilde          */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Adiaeresis      Aring           AE              Ccedilla        */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Egrave          Eacute          Ecircumflex     Ediaeresis      */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Igrave          Iacute          Icircumflex     Idiaeresis      */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Eth             Ntilde          Ograve          Oacute          */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Ocircumflex     Otilde          Odiaeresis      multiply        */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Ooblique        Ugrave          Uacute          Ucircumflex     */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Udiaeresis      Yacute          Thorn           ssharp          */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      agrave          aacute          acircumflex     atilde          */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      adiaeresis      aring           ae              ccedilla        */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      egrave          eacute          ecircumflex     ediaeresis      */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      igrave          iacute          icircumflex     idiaeresis      */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      eth             ntilde          ograve          oacute          */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      ocircumflex     otilde          odiaeresis      division        */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      oslash          ugrave          uacute          ucircumflex     */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      udiaeresis      yacute          thorn           ydiaeresis      */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
  };

  // ESC ( etc.
  public final static int[] scsTable =
  {
    /*	NUL		SOH		STX		ETX	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	EOT		ENQ		ACK		BEL	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_BELL,
    /*	BS		HT		NL		VT	*/
    CASE_BS,
    CASE_TAB,
    CASE_VMOT,
    CASE_VMOT,
    /*	NP		CR		SO		SI	*/
    CASE_VMOT,
    CASE_CR,
    CASE_SO,
    CASE_SI,
    /*	DLE		DC1		DC2		DC3	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	DC4		NAK		SYN		ETB	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	CAN		EM		SUB		ESC	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_ESC,
    /*	FS		GS		RS		US	*/
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*	SP		!		"		#	*/
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    /*	$		%		&		'	*/
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    /*	(		)		*		+	*/
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    /*	,		-		.		/	*/
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    CASE_ESC_IGNORE,
    /*	0		1		2		3	*/
    CASE_GSETS,
    CASE_GSETS,
    CASE_GSETS,
    CASE_GROUND_STATE,
    /*	4		5		6		7	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	8		9		:		;	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	<		=		>		?	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	@		A		B		C	*/
    CASE_GROUND_STATE,
    CASE_GSETS,
    CASE_GSETS,
    CASE_GROUND_STATE,
    /*	D		E		F		G	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	H		I		J		K	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	L		M		N		O	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	P		Q		R		S	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	T		U		V		W	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	X		Y		Z		[	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	\		]		^		_	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	`		a		b		c	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	d		e		f		g	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	h		i		j		k	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	l		m		n		o	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	p		q		r		s	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	t		u		v		w	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	x		y		z		{	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*	|		}		~		DEL	*/
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      0x80            0x81            0x82            0x83    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x84            0x85            0x86            0x87    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x88            0x89            0x8a            0x8b    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x8c            0x8d            0x8e            0x8f    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x90            0x91            0x92            0x93    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x94            0x95            0x96            0x97    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x99            0x99            0x9a            0x9b    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      0x9c            0x9d            0x9e            0x9f    */
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    CASE_IGNORE,
    /*      nobreakspace    exclamdown      cent            sterling        */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      currency        yen             brokenbar       section         */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      diaeresis       copyright       ordfeminine     guillemotleft   */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      notsign         hyphen          registered      macron          */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      degree          plusminus       twosuperior     threesuperior   */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      acute           mu              paragraph       periodcentered  */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      cedilla         onesuperior     masculine       guillemotright  */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      onequarter      onehalf         threequarters   questiondown    */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Agrave          Aacute          Acircumflex     Atilde          */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Adiaeresis      Aring           AE              Ccedilla        */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Egrave          Eacute          Ecircumflex     Ediaeresis      */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Igrave          Iacute          Icircumflex     Idiaeresis      */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Eth             Ntilde          Ograve          Oacute          */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Ocircumflex     Otilde          Odiaeresis      multiply        */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Ooblique        Ugrave          Uacute          Ucircumflex     */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      Udiaeresis      Yacute          Thorn           ssharp          */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      agrave          aacute          acircumflex     atilde          */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      adiaeresis      aring           ae              ccedilla        */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      egrave          eacute          ecircumflex     ediaeresis      */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      igrave          iacute          icircumflex     idiaeresis      */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      eth             ntilde          ograve          oacute          */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      ocircumflex     otilde          odiaeresis      division        */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      oslash          ugrave          uacute          ucircumflex     */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    /*      udiaeresis      yacute          thorn           ydiaeresis      */
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
    CASE_GROUND_STATE,
  };

}
